// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/ClusterJoinInfo.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_JOIN_INFO__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_JOIN_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'cluster_id'
#include "etsi_its_vam_ts_msgs/msg/detail/identifier1_b__struct.hpp"
// Member 'join_time'
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_quarter_second__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterJoinInfo __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterJoinInfo __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClusterJoinInfo_
{
  using Type = ClusterJoinInfo_<ContainerAllocator>;

  explicit ClusterJoinInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cluster_id(_init),
    join_time(_init)
  {
    (void)_init;
  }

  explicit ClusterJoinInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cluster_id(_alloc, _init),
    join_time(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _cluster_id_type =
    etsi_its_vam_ts_msgs::msg::Identifier1B_<ContainerAllocator>;
  _cluster_id_type cluster_id;
  using _join_time_type =
    etsi_its_vam_ts_msgs::msg::DeltaTimeQuarterSecond_<ContainerAllocator>;
  _join_time_type join_time;

  // setters for named parameter idiom
  Type & set__cluster_id(
    const etsi_its_vam_ts_msgs::msg::Identifier1B_<ContainerAllocator> & _arg)
  {
    this->cluster_id = _arg;
    return *this;
  }
  Type & set__join_time(
    const etsi_its_vam_ts_msgs::msg::DeltaTimeQuarterSecond_<ContainerAllocator> & _arg)
  {
    this->join_time = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterJoinInfo
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterJoinInfo
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClusterJoinInfo_ & other) const
  {
    if (this->cluster_id != other.cluster_id) {
      return false;
    }
    if (this->join_time != other.join_time) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClusterJoinInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClusterJoinInfo_

// alias to use template instance with default allocator
using ClusterJoinInfo =
  etsi_its_vam_ts_msgs::msg::ClusterJoinInfo_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_JOIN_INFO__STRUCT_HPP_
