// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/VamParameters.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VAM_PARAMETERS__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VAM_PARAMETERS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'basic_container'
#include "etsi_its_vam_ts_msgs/msg/detail/basic_container__struct.hpp"
// Member 'vru_high_frequency_container'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_high_frequency_container__struct.hpp"
// Member 'vru_low_frequency_container'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_low_frequency_container__struct.hpp"
// Member 'vru_cluster_information_container'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_cluster_information_container__struct.hpp"
// Member 'vru_cluster_operation_container'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_cluster_operation_container__struct.hpp"
// Member 'vru_motion_prediction_container'
#include "etsi_its_vam_ts_msgs/msg/detail/vru_motion_prediction_container__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VamParameters __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__VamParameters __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct VamParameters_
{
  using Type = VamParameters_<ContainerAllocator>;

  explicit VamParameters_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : basic_container(_init),
    vru_high_frequency_container(_init),
    vru_low_frequency_container(_init),
    vru_cluster_information_container(_init),
    vru_cluster_operation_container(_init),
    vru_motion_prediction_container(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->vru_low_frequency_container_is_present = false;
      this->vru_cluster_information_container_is_present = false;
      this->vru_cluster_operation_container_is_present = false;
      this->vru_motion_prediction_container_is_present = false;
    }
  }

  explicit VamParameters_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : basic_container(_alloc, _init),
    vru_high_frequency_container(_alloc, _init),
    vru_low_frequency_container(_alloc, _init),
    vru_cluster_information_container(_alloc, _init),
    vru_cluster_operation_container(_alloc, _init),
    vru_motion_prediction_container(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->vru_low_frequency_container_is_present = false;
      this->vru_cluster_information_container_is_present = false;
      this->vru_cluster_operation_container_is_present = false;
      this->vru_motion_prediction_container_is_present = false;
    }
  }

  // field types and members
  using _basic_container_type =
    etsi_its_vam_ts_msgs::msg::BasicContainer_<ContainerAllocator>;
  _basic_container_type basic_container;
  using _vru_high_frequency_container_type =
    etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator>;
  _vru_high_frequency_container_type vru_high_frequency_container;
  using _vru_low_frequency_container_type =
    etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator>;
  _vru_low_frequency_container_type vru_low_frequency_container;
  using _vru_low_frequency_container_is_present_type =
    bool;
  _vru_low_frequency_container_is_present_type vru_low_frequency_container_is_present;
  using _vru_cluster_information_container_type =
    etsi_its_vam_ts_msgs::msg::VruClusterInformationContainer_<ContainerAllocator>;
  _vru_cluster_information_container_type vru_cluster_information_container;
  using _vru_cluster_information_container_is_present_type =
    bool;
  _vru_cluster_information_container_is_present_type vru_cluster_information_container_is_present;
  using _vru_cluster_operation_container_type =
    etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator>;
  _vru_cluster_operation_container_type vru_cluster_operation_container;
  using _vru_cluster_operation_container_is_present_type =
    bool;
  _vru_cluster_operation_container_is_present_type vru_cluster_operation_container_is_present;
  using _vru_motion_prediction_container_type =
    etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator>;
  _vru_motion_prediction_container_type vru_motion_prediction_container;
  using _vru_motion_prediction_container_is_present_type =
    bool;
  _vru_motion_prediction_container_is_present_type vru_motion_prediction_container_is_present;

  // setters for named parameter idiom
  Type & set__basic_container(
    const etsi_its_vam_ts_msgs::msg::BasicContainer_<ContainerAllocator> & _arg)
  {
    this->basic_container = _arg;
    return *this;
  }
  Type & set__vru_high_frequency_container(
    const etsi_its_vam_ts_msgs::msg::VruHighFrequencyContainer_<ContainerAllocator> & _arg)
  {
    this->vru_high_frequency_container = _arg;
    return *this;
  }
  Type & set__vru_low_frequency_container(
    const etsi_its_vam_ts_msgs::msg::VruLowFrequencyContainer_<ContainerAllocator> & _arg)
  {
    this->vru_low_frequency_container = _arg;
    return *this;
  }
  Type & set__vru_low_frequency_container_is_present(
    const bool & _arg)
  {
    this->vru_low_frequency_container_is_present = _arg;
    return *this;
  }
  Type & set__vru_cluster_information_container(
    const etsi_its_vam_ts_msgs::msg::VruClusterInformationContainer_<ContainerAllocator> & _arg)
  {
    this->vru_cluster_information_container = _arg;
    return *this;
  }
  Type & set__vru_cluster_information_container_is_present(
    const bool & _arg)
  {
    this->vru_cluster_information_container_is_present = _arg;
    return *this;
  }
  Type & set__vru_cluster_operation_container(
    const etsi_its_vam_ts_msgs::msg::VruClusterOperationContainer_<ContainerAllocator> & _arg)
  {
    this->vru_cluster_operation_container = _arg;
    return *this;
  }
  Type & set__vru_cluster_operation_container_is_present(
    const bool & _arg)
  {
    this->vru_cluster_operation_container_is_present = _arg;
    return *this;
  }
  Type & set__vru_motion_prediction_container(
    const etsi_its_vam_ts_msgs::msg::VruMotionPredictionContainer_<ContainerAllocator> & _arg)
  {
    this->vru_motion_prediction_container = _arg;
    return *this;
  }
  Type & set__vru_motion_prediction_container_is_present(
    const bool & _arg)
  {
    this->vru_motion_prediction_container_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VamParameters
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__VamParameters
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::VamParameters_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const VamParameters_ & other) const
  {
    if (this->basic_container != other.basic_container) {
      return false;
    }
    if (this->vru_high_frequency_container != other.vru_high_frequency_container) {
      return false;
    }
    if (this->vru_low_frequency_container != other.vru_low_frequency_container) {
      return false;
    }
    if (this->vru_low_frequency_container_is_present != other.vru_low_frequency_container_is_present) {
      return false;
    }
    if (this->vru_cluster_information_container != other.vru_cluster_information_container) {
      return false;
    }
    if (this->vru_cluster_information_container_is_present != other.vru_cluster_information_container_is_present) {
      return false;
    }
    if (this->vru_cluster_operation_container != other.vru_cluster_operation_container) {
      return false;
    }
    if (this->vru_cluster_operation_container_is_present != other.vru_cluster_operation_container_is_present) {
      return false;
    }
    if (this->vru_motion_prediction_container != other.vru_motion_prediction_container) {
      return false;
    }
    if (this->vru_motion_prediction_container_is_present != other.vru_motion_prediction_container_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const VamParameters_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct VamParameters_

// alias to use template instance with default allocator
using VamParameters =
  etsi_its_vam_ts_msgs::msg::VamParameters_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VAM_PARAMETERS__STRUCT_HPP_
