// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_vam_ts_msgs:msg/VruMotionPredictionContainer.idl
// generated code does not contain a copyright notice
#include "etsi_its_vam_ts_msgs/msg/detail/vru_motion_prediction_container__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `path_history`
#include "etsi_its_vam_ts_msgs/msg/detail/path_history__functions.h"
// Member `path_prediction`
#include "etsi_its_vam_ts_msgs/msg/detail/path_predicted__functions.h"
// Member `safe_distance`
#include "etsi_its_vam_ts_msgs/msg/detail/sequence_of_safe_distance_indication__functions.h"
// Member `trajectory_interception_indication`
#include "etsi_its_vam_ts_msgs/msg/detail/sequence_of_trajectory_interception_indication__functions.h"
// Member `acceleration_change_indication`
#include "etsi_its_vam_ts_msgs/msg/detail/acceleration_change_indication__functions.h"
// Member `heading_change_indication`
#include "etsi_its_vam_ts_msgs/msg/detail/heading_change_indication__functions.h"
// Member `stability_change_indication`
#include "etsi_its_vam_ts_msgs/msg/detail/stability_change_indication__functions.h"

bool
etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__init(etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer * msg)
{
  if (!msg) {
    return false;
  }
  // path_history
  if (!etsi_its_vam_ts_msgs__msg__PathHistory__init(&msg->path_history)) {
    etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__fini(msg);
    return false;
  }
  // path_history_is_present
  // path_prediction
  if (!etsi_its_vam_ts_msgs__msg__PathPredicted__init(&msg->path_prediction)) {
    etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__fini(msg);
    return false;
  }
  // path_prediction_is_present
  // safe_distance
  if (!etsi_its_vam_ts_msgs__msg__SequenceOfSafeDistanceIndication__init(&msg->safe_distance)) {
    etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__fini(msg);
    return false;
  }
  // safe_distance_is_present
  // trajectory_interception_indication
  if (!etsi_its_vam_ts_msgs__msg__SequenceOfTrajectoryInterceptionIndication__init(&msg->trajectory_interception_indication)) {
    etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__fini(msg);
    return false;
  }
  // trajectory_interception_indication_is_present
  // acceleration_change_indication
  if (!etsi_its_vam_ts_msgs__msg__AccelerationChangeIndication__init(&msg->acceleration_change_indication)) {
    etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__fini(msg);
    return false;
  }
  // acceleration_change_indication_is_present
  // heading_change_indication
  if (!etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__init(&msg->heading_change_indication)) {
    etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__fini(msg);
    return false;
  }
  // heading_change_indication_is_present
  // stability_change_indication
  if (!etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__init(&msg->stability_change_indication)) {
    etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__fini(msg);
    return false;
  }
  // stability_change_indication_is_present
  return true;
}

void
etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__fini(etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer * msg)
{
  if (!msg) {
    return;
  }
  // path_history
  etsi_its_vam_ts_msgs__msg__PathHistory__fini(&msg->path_history);
  // path_history_is_present
  // path_prediction
  etsi_its_vam_ts_msgs__msg__PathPredicted__fini(&msg->path_prediction);
  // path_prediction_is_present
  // safe_distance
  etsi_its_vam_ts_msgs__msg__SequenceOfSafeDistanceIndication__fini(&msg->safe_distance);
  // safe_distance_is_present
  // trajectory_interception_indication
  etsi_its_vam_ts_msgs__msg__SequenceOfTrajectoryInterceptionIndication__fini(&msg->trajectory_interception_indication);
  // trajectory_interception_indication_is_present
  // acceleration_change_indication
  etsi_its_vam_ts_msgs__msg__AccelerationChangeIndication__fini(&msg->acceleration_change_indication);
  // acceleration_change_indication_is_present
  // heading_change_indication
  etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__fini(&msg->heading_change_indication);
  // heading_change_indication_is_present
  // stability_change_indication
  etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__fini(&msg->stability_change_indication);
  // stability_change_indication_is_present
}

bool
etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__are_equal(const etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer * lhs, const etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // path_history
  if (!etsi_its_vam_ts_msgs__msg__PathHistory__are_equal(
      &(lhs->path_history), &(rhs->path_history)))
  {
    return false;
  }
  // path_history_is_present
  if (lhs->path_history_is_present != rhs->path_history_is_present) {
    return false;
  }
  // path_prediction
  if (!etsi_its_vam_ts_msgs__msg__PathPredicted__are_equal(
      &(lhs->path_prediction), &(rhs->path_prediction)))
  {
    return false;
  }
  // path_prediction_is_present
  if (lhs->path_prediction_is_present != rhs->path_prediction_is_present) {
    return false;
  }
  // safe_distance
  if (!etsi_its_vam_ts_msgs__msg__SequenceOfSafeDistanceIndication__are_equal(
      &(lhs->safe_distance), &(rhs->safe_distance)))
  {
    return false;
  }
  // safe_distance_is_present
  if (lhs->safe_distance_is_present != rhs->safe_distance_is_present) {
    return false;
  }
  // trajectory_interception_indication
  if (!etsi_its_vam_ts_msgs__msg__SequenceOfTrajectoryInterceptionIndication__are_equal(
      &(lhs->trajectory_interception_indication), &(rhs->trajectory_interception_indication)))
  {
    return false;
  }
  // trajectory_interception_indication_is_present
  if (lhs->trajectory_interception_indication_is_present != rhs->trajectory_interception_indication_is_present) {
    return false;
  }
  // acceleration_change_indication
  if (!etsi_its_vam_ts_msgs__msg__AccelerationChangeIndication__are_equal(
      &(lhs->acceleration_change_indication), &(rhs->acceleration_change_indication)))
  {
    return false;
  }
  // acceleration_change_indication_is_present
  if (lhs->acceleration_change_indication_is_present != rhs->acceleration_change_indication_is_present) {
    return false;
  }
  // heading_change_indication
  if (!etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__are_equal(
      &(lhs->heading_change_indication), &(rhs->heading_change_indication)))
  {
    return false;
  }
  // heading_change_indication_is_present
  if (lhs->heading_change_indication_is_present != rhs->heading_change_indication_is_present) {
    return false;
  }
  // stability_change_indication
  if (!etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__are_equal(
      &(lhs->stability_change_indication), &(rhs->stability_change_indication)))
  {
    return false;
  }
  // stability_change_indication_is_present
  if (lhs->stability_change_indication_is_present != rhs->stability_change_indication_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__copy(
  const etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer * input,
  etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer * output)
{
  if (!input || !output) {
    return false;
  }
  // path_history
  if (!etsi_its_vam_ts_msgs__msg__PathHistory__copy(
      &(input->path_history), &(output->path_history)))
  {
    return false;
  }
  // path_history_is_present
  output->path_history_is_present = input->path_history_is_present;
  // path_prediction
  if (!etsi_its_vam_ts_msgs__msg__PathPredicted__copy(
      &(input->path_prediction), &(output->path_prediction)))
  {
    return false;
  }
  // path_prediction_is_present
  output->path_prediction_is_present = input->path_prediction_is_present;
  // safe_distance
  if (!etsi_its_vam_ts_msgs__msg__SequenceOfSafeDistanceIndication__copy(
      &(input->safe_distance), &(output->safe_distance)))
  {
    return false;
  }
  // safe_distance_is_present
  output->safe_distance_is_present = input->safe_distance_is_present;
  // trajectory_interception_indication
  if (!etsi_its_vam_ts_msgs__msg__SequenceOfTrajectoryInterceptionIndication__copy(
      &(input->trajectory_interception_indication), &(output->trajectory_interception_indication)))
  {
    return false;
  }
  // trajectory_interception_indication_is_present
  output->trajectory_interception_indication_is_present = input->trajectory_interception_indication_is_present;
  // acceleration_change_indication
  if (!etsi_its_vam_ts_msgs__msg__AccelerationChangeIndication__copy(
      &(input->acceleration_change_indication), &(output->acceleration_change_indication)))
  {
    return false;
  }
  // acceleration_change_indication_is_present
  output->acceleration_change_indication_is_present = input->acceleration_change_indication_is_present;
  // heading_change_indication
  if (!etsi_its_vam_ts_msgs__msg__HeadingChangeIndication__copy(
      &(input->heading_change_indication), &(output->heading_change_indication)))
  {
    return false;
  }
  // heading_change_indication_is_present
  output->heading_change_indication_is_present = input->heading_change_indication_is_present;
  // stability_change_indication
  if (!etsi_its_vam_ts_msgs__msg__StabilityChangeIndication__copy(
      &(input->stability_change_indication), &(output->stability_change_indication)))
  {
    return false;
  }
  // stability_change_indication_is_present
  output->stability_change_indication_is_present = input->stability_change_indication_is_present;
  return true;
}

etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer *
etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer * msg = (etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer));
  bool success = etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__destroy(etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence__init(etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer * data = NULL;

  if (size) {
    data = (etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer *)allocator.zero_allocate(size, sizeof(etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence__fini(etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence *
etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence * array = (etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence__destroy(etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence__are_equal(const etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence * lhs, const etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence__copy(
  const etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence * input,
  etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer * data =
      (etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
