// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/VruSizeClass.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_SIZE_CLASS__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_SIZE_CLASS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruSizeClass__UNAVAILABLE = 0
};

/// Constant 'LOW'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruSizeClass__LOW = 1
};

/// Constant 'MEDIUM'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruSizeClass__MEDIUM = 2
};

/// Constant 'HIGH'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruSizeClass__HIGH = 3
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__VruSizeClass__MAX = 15
};

/// Struct defined in msg/VruSizeClass in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__VruSizeClass
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
  ///   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   vam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the approximate size of a VRU including the VRU vehicle used.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `unavailable`    - to indicate that there is no matched size class or due to privacy reasons in profile 1,
  ///  * - 1 `low`            - to indicate that the VRU size class is low depending on the VRU profile,
  ///  * - 2 `medium`         - to indicate that the VRU size class is medium depending on the VRU profile,
  ///  * - 3 `high`           - to indicate that the VRU size class is high depending on the VRU profile.
  ///  * - 4 to 15            - are reserved for future usage. Value 15 is set to "max" in order to bound the size of the encoded field.
  ///  *
  ///  * @category: VRU information
  ///  * @revision: Created in V2.1.1
  ///  */
  /// VruSizeClass ::= ENUMERATED {
  ///     unavailable (0),
  ///     low         (1),
  ///     medium      (2),
  ///     high        (3),
  ///     max         (15)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_vam_ts_msgs__msg__VruSizeClass;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__VruSizeClass.
typedef struct etsi_its_vam_ts_msgs__msg__VruSizeClass__Sequence
{
  etsi_its_vam_ts_msgs__msg__VruSizeClass * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__VruSizeClass__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__VRU_SIZE_CLASS__STRUCT_H_
