// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/ClusterLeaveInfo.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_LEAVE_INFO__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_LEAVE_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'cluster_id'
#include "etsi_its_vam_ts_msgs/msg/detail/identifier1_b__struct.hpp"
// Member 'cluster_leave_reason'
#include "etsi_its_vam_ts_msgs/msg/detail/cluster_leave_reason__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterLeaveInfo __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterLeaveInfo __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClusterLeaveInfo_
{
  using Type = ClusterLeaveInfo_<ContainerAllocator>;

  explicit ClusterLeaveInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cluster_id(_init),
    cluster_leave_reason(_init)
  {
    (void)_init;
  }

  explicit ClusterLeaveInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cluster_id(_alloc, _init),
    cluster_leave_reason(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _cluster_id_type =
    etsi_its_vam_ts_msgs::msg::Identifier1B_<ContainerAllocator>;
  _cluster_id_type cluster_id;
  using _cluster_leave_reason_type =
    etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator>;
  _cluster_leave_reason_type cluster_leave_reason;

  // setters for named parameter idiom
  Type & set__cluster_id(
    const etsi_its_vam_ts_msgs::msg::Identifier1B_<ContainerAllocator> & _arg)
  {
    this->cluster_id = _arg;
    return *this;
  }
  Type & set__cluster_leave_reason(
    const etsi_its_vam_ts_msgs::msg::ClusterLeaveReason_<ContainerAllocator> & _arg)
  {
    this->cluster_leave_reason = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterLeaveInfo
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__ClusterLeaveInfo
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClusterLeaveInfo_ & other) const
  {
    if (this->cluster_id != other.cluster_id) {
      return false;
    }
    if (this->cluster_leave_reason != other.cluster_leave_reason) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClusterLeaveInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClusterLeaveInfo_

// alias to use template instance with default allocator
using ClusterLeaveInfo =
  etsi_its_vam_ts_msgs::msg::ClusterLeaveInfo_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__CLUSTER_LEAVE_INFO__STRUCT_HPP_
