// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/GeneralizedLanePosition.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'traffic_lane_position'
#include "etsi_its_vam_ts_msgs/msg/detail/lane_position__struct.hpp"
// Member 'non_traffic_lane_position'
#include "etsi_its_vam_ts_msgs/msg/detail/lane_position_and_type__struct.hpp"
// Member 'traffic_island_position'
#include "etsi_its_vam_ts_msgs/msg/detail/traffic_island_position__struct.hpp"
// Member 'map_position'
#include "etsi_its_vam_ts_msgs/msg/detail/map_position__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GeneralizedLanePosition_
{
  using Type = GeneralizedLanePosition_<ContainerAllocator>;

  explicit GeneralizedLanePosition_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : traffic_lane_position(_init),
    non_traffic_lane_position(_init),
    traffic_island_position(_init),
    map_position(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  explicit GeneralizedLanePosition_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : traffic_lane_position(_alloc, _init),
    non_traffic_lane_position(_alloc, _init),
    traffic_island_position(_alloc, _init),
    map_position(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->choice = 0;
    }
  }

  // field types and members
  using _choice_type =
    uint8_t;
  _choice_type choice;
  using _traffic_lane_position_type =
    etsi_its_vam_ts_msgs::msg::LanePosition_<ContainerAllocator>;
  _traffic_lane_position_type traffic_lane_position;
  using _non_traffic_lane_position_type =
    etsi_its_vam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator>;
  _non_traffic_lane_position_type non_traffic_lane_position;
  using _traffic_island_position_type =
    etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator>;
  _traffic_island_position_type traffic_island_position;
  using _map_position_type =
    etsi_its_vam_ts_msgs::msg::MapPosition_<ContainerAllocator>;
  _map_position_type map_position;

  // setters for named parameter idiom
  Type & set__choice(
    const uint8_t & _arg)
  {
    this->choice = _arg;
    return *this;
  }
  Type & set__traffic_lane_position(
    const etsi_its_vam_ts_msgs::msg::LanePosition_<ContainerAllocator> & _arg)
  {
    this->traffic_lane_position = _arg;
    return *this;
  }
  Type & set__non_traffic_lane_position(
    const etsi_its_vam_ts_msgs::msg::LanePositionAndType_<ContainerAllocator> & _arg)
  {
    this->non_traffic_lane_position = _arg;
    return *this;
  }
  Type & set__traffic_island_position(
    const etsi_its_vam_ts_msgs::msg::TrafficIslandPosition_<ContainerAllocator> & _arg)
  {
    this->traffic_island_position = _arg;
    return *this;
  }
  Type & set__map_position(
    const etsi_its_vam_ts_msgs::msg::MapPosition_<ContainerAllocator> & _arg)
  {
    this->map_position = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t CHOICE_TRAFFIC_LANE_POSITION =
    0u;
  static constexpr uint8_t CHOICE_NON_TRAFFIC_LANE_POSITION =
    1u;
  static constexpr uint8_t CHOICE_TRAFFIC_ISLAND_POSITION =
    2u;
  static constexpr uint8_t CHOICE_MAP_POSITION =
    3u;

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__GeneralizedLanePosition
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GeneralizedLanePosition_ & other) const
  {
    if (this->choice != other.choice) {
      return false;
    }
    if (this->traffic_lane_position != other.traffic_lane_position) {
      return false;
    }
    if (this->non_traffic_lane_position != other.non_traffic_lane_position) {
      return false;
    }
    if (this->traffic_island_position != other.traffic_island_position) {
      return false;
    }
    if (this->map_position != other.map_position) {
      return false;
    }
    return true;
  }
  bool operator!=(const GeneralizedLanePosition_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GeneralizedLanePosition_

// alias to use template instance with default allocator
using GeneralizedLanePosition =
  etsi_its_vam_ts_msgs::msg::GeneralizedLanePosition_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GeneralizedLanePosition_<ContainerAllocator>::CHOICE_TRAFFIC_LANE_POSITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GeneralizedLanePosition_<ContainerAllocator>::CHOICE_NON_TRAFFIC_LANE_POSITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GeneralizedLanePosition_<ContainerAllocator>::CHOICE_TRAFFIC_ISLAND_POSITION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t GeneralizedLanePosition_<ContainerAllocator>::CHOICE_MAP_POSITION;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__STRUCT_HPP_
