// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_vam_ts_msgs:msg/SafeDistanceIndication.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__SAFE_DISTANCE_INDICATION__STRUCT_HPP_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__SAFE_DISTANCE_INDICATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'subject_station'
#include "etsi_its_vam_ts_msgs/msg/detail/station_id__struct.hpp"
// Member 'safe_distance_indicator'
#include "etsi_its_vam_ts_msgs/msg/detail/safe_distance_indicator__struct.hpp"
// Member 'time_to_collision'
#include "etsi_its_vam_ts_msgs/msg/detail/delta_time_tenth_of_second__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__SafeDistanceIndication __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_vam_ts_msgs__msg__SafeDistanceIndication __declspec(deprecated)
#endif

namespace etsi_its_vam_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SafeDistanceIndication_
{
  using Type = SafeDistanceIndication_<ContainerAllocator>;

  explicit SafeDistanceIndication_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : subject_station(_init),
    safe_distance_indicator(_init),
    time_to_collision(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->subject_station_is_present = false;
      this->time_to_collision_is_present = false;
    }
  }

  explicit SafeDistanceIndication_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : subject_station(_alloc, _init),
    safe_distance_indicator(_alloc, _init),
    time_to_collision(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->subject_station_is_present = false;
      this->time_to_collision_is_present = false;
    }
  }

  // field types and members
  using _subject_station_type =
    etsi_its_vam_ts_msgs::msg::StationId_<ContainerAllocator>;
  _subject_station_type subject_station;
  using _subject_station_is_present_type =
    bool;
  _subject_station_is_present_type subject_station_is_present;
  using _safe_distance_indicator_type =
    etsi_its_vam_ts_msgs::msg::SafeDistanceIndicator_<ContainerAllocator>;
  _safe_distance_indicator_type safe_distance_indicator;
  using _time_to_collision_type =
    etsi_its_vam_ts_msgs::msg::DeltaTimeTenthOfSecond_<ContainerAllocator>;
  _time_to_collision_type time_to_collision;
  using _time_to_collision_is_present_type =
    bool;
  _time_to_collision_is_present_type time_to_collision_is_present;

  // setters for named parameter idiom
  Type & set__subject_station(
    const etsi_its_vam_ts_msgs::msg::StationId_<ContainerAllocator> & _arg)
  {
    this->subject_station = _arg;
    return *this;
  }
  Type & set__subject_station_is_present(
    const bool & _arg)
  {
    this->subject_station_is_present = _arg;
    return *this;
  }
  Type & set__safe_distance_indicator(
    const etsi_its_vam_ts_msgs::msg::SafeDistanceIndicator_<ContainerAllocator> & _arg)
  {
    this->safe_distance_indicator = _arg;
    return *this;
  }
  Type & set__time_to_collision(
    const etsi_its_vam_ts_msgs::msg::DeltaTimeTenthOfSecond_<ContainerAllocator> & _arg)
  {
    this->time_to_collision = _arg;
    return *this;
  }
  Type & set__time_to_collision_is_present(
    const bool & _arg)
  {
    this->time_to_collision_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_vam_ts_msgs::msg::SafeDistanceIndication_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_vam_ts_msgs::msg::SafeDistanceIndication_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::SafeDistanceIndication_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::SafeDistanceIndication_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::SafeDistanceIndication_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::SafeDistanceIndication_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_vam_ts_msgs::msg::SafeDistanceIndication_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_vam_ts_msgs::msg::SafeDistanceIndication_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::SafeDistanceIndication_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_vam_ts_msgs::msg::SafeDistanceIndication_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__SafeDistanceIndication
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::SafeDistanceIndication_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_vam_ts_msgs__msg__SafeDistanceIndication
    std::shared_ptr<etsi_its_vam_ts_msgs::msg::SafeDistanceIndication_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SafeDistanceIndication_ & other) const
  {
    if (this->subject_station != other.subject_station) {
      return false;
    }
    if (this->subject_station_is_present != other.subject_station_is_present) {
      return false;
    }
    if (this->safe_distance_indicator != other.safe_distance_indicator) {
      return false;
    }
    if (this->time_to_collision != other.time_to_collision) {
      return false;
    }
    if (this->time_to_collision_is_present != other.time_to_collision_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const SafeDistanceIndication_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SafeDistanceIndication_

// alias to use template instance with default allocator
using SafeDistanceIndication =
  etsi_its_vam_ts_msgs::msg::SafeDistanceIndication_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_vam_ts_msgs

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__SAFE_DISTANCE_INDICATION__STRUCT_HPP_
