// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_vam_ts_msgs:msg/StabilityLossProbability.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__STABILITY_LOSS_PROBABILITY__STRUCT_H_
#define ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__STABILITY_LOSS_PROBABILITY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_vam_ts_msgs__msg__StabilityLossProbability__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_vam_ts_msgs__msg__StabilityLossProbability__MAX = 63
};

/// Constant 'STABLE'.
enum
{
  etsi_its_vam_ts_msgs__msg__StabilityLossProbability__STABLE = 0
};

/// Constant 'TOTAL_LOSS_OF_STABILITY'.
enum
{
  etsi_its_vam_ts_msgs__msg__StabilityLossProbability__TOTAL_LOSS_OF_STABILITY = 50
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_vam_ts_msgs__msg__StabilityLossProbability__UNAVAILABLE = 63
};

/// Struct defined in msg/StabilityLossProbability in the package etsi_its_vam_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_vam_ts_msgs__msg__StabilityLossProbability
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/vam-ts103300_3/VAM-PDU-Descriptions.asn
  ///   asn1/patched/vam-ts103300_3/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   vam_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_vam_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the estimated probability of a stability level and conversely also the probability of a stability loss.
  ///  *
  ///  * The value shall be set to:
  ///  * - `0` to indicate an estimated probability of a loss of stability of 0 %, i.e. "stable",
  ///  * - `n` (`n > 0` and `n < 50`) to indicate the actual stability level,
  ///  * - `50` to indicate a estimated probability of a loss of stability of 100 %, i.e. "total loss of stability",
  ///  * - the values between 51 and 62 are reserved for future use,
  ///  * - `63`: this value indicates that the information is unavailable.
  ///  *
  ///  * @unit: 2 %
  ///  * @category: Kinematic information
  ///  * @revision: Created in V2.1.1
  ///  */
  /// StabilityLossProbability ::= INTEGER {
  ///     stable                  (0),
  ///     totalLossOfStability   (50),
  ///     unavailable            (63)
  /// } (0..63)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_vam_ts_msgs__msg__StabilityLossProbability;

// Struct for a sequence of etsi_its_vam_ts_msgs__msg__StabilityLossProbability.
typedef struct etsi_its_vam_ts_msgs__msg__StabilityLossProbability__Sequence
{
  etsi_its_vam_ts_msgs__msg__StabilityLossProbability * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_vam_ts_msgs__msg__StabilityLossProbability__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_VAM_TS_MSGS__MSG__DETAIL__STABILITY_LOSS_PROBABILITY__STRUCT_H_
