// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_vam_ts_msgs:msg/VamParameters.idl
// generated code does not contain a copyright notice
#include "etsi_its_vam_ts_msgs/msg/detail/vam_parameters__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `basic_container`
#include "etsi_its_vam_ts_msgs/msg/detail/basic_container__functions.h"
// Member `vru_high_frequency_container`
#include "etsi_its_vam_ts_msgs/msg/detail/vru_high_frequency_container__functions.h"
// Member `vru_low_frequency_container`
#include "etsi_its_vam_ts_msgs/msg/detail/vru_low_frequency_container__functions.h"
// Member `vru_cluster_information_container`
#include "etsi_its_vam_ts_msgs/msg/detail/vru_cluster_information_container__functions.h"
// Member `vru_cluster_operation_container`
#include "etsi_its_vam_ts_msgs/msg/detail/vru_cluster_operation_container__functions.h"
// Member `vru_motion_prediction_container`
#include "etsi_its_vam_ts_msgs/msg/detail/vru_motion_prediction_container__functions.h"

bool
etsi_its_vam_ts_msgs__msg__VamParameters__init(etsi_its_vam_ts_msgs__msg__VamParameters * msg)
{
  if (!msg) {
    return false;
  }
  // basic_container
  if (!etsi_its_vam_ts_msgs__msg__BasicContainer__init(&msg->basic_container)) {
    etsi_its_vam_ts_msgs__msg__VamParameters__fini(msg);
    return false;
  }
  // vru_high_frequency_container
  if (!etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer__init(&msg->vru_high_frequency_container)) {
    etsi_its_vam_ts_msgs__msg__VamParameters__fini(msg);
    return false;
  }
  // vru_low_frequency_container
  if (!etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer__init(&msg->vru_low_frequency_container)) {
    etsi_its_vam_ts_msgs__msg__VamParameters__fini(msg);
    return false;
  }
  // vru_low_frequency_container_is_present
  // vru_cluster_information_container
  if (!etsi_its_vam_ts_msgs__msg__VruClusterInformationContainer__init(&msg->vru_cluster_information_container)) {
    etsi_its_vam_ts_msgs__msg__VamParameters__fini(msg);
    return false;
  }
  // vru_cluster_information_container_is_present
  // vru_cluster_operation_container
  if (!etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__init(&msg->vru_cluster_operation_container)) {
    etsi_its_vam_ts_msgs__msg__VamParameters__fini(msg);
    return false;
  }
  // vru_cluster_operation_container_is_present
  // vru_motion_prediction_container
  if (!etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__init(&msg->vru_motion_prediction_container)) {
    etsi_its_vam_ts_msgs__msg__VamParameters__fini(msg);
    return false;
  }
  // vru_motion_prediction_container_is_present
  return true;
}

void
etsi_its_vam_ts_msgs__msg__VamParameters__fini(etsi_its_vam_ts_msgs__msg__VamParameters * msg)
{
  if (!msg) {
    return;
  }
  // basic_container
  etsi_its_vam_ts_msgs__msg__BasicContainer__fini(&msg->basic_container);
  // vru_high_frequency_container
  etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer__fini(&msg->vru_high_frequency_container);
  // vru_low_frequency_container
  etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer__fini(&msg->vru_low_frequency_container);
  // vru_low_frequency_container_is_present
  // vru_cluster_information_container
  etsi_its_vam_ts_msgs__msg__VruClusterInformationContainer__fini(&msg->vru_cluster_information_container);
  // vru_cluster_information_container_is_present
  // vru_cluster_operation_container
  etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__fini(&msg->vru_cluster_operation_container);
  // vru_cluster_operation_container_is_present
  // vru_motion_prediction_container
  etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__fini(&msg->vru_motion_prediction_container);
  // vru_motion_prediction_container_is_present
}

bool
etsi_its_vam_ts_msgs__msg__VamParameters__are_equal(const etsi_its_vam_ts_msgs__msg__VamParameters * lhs, const etsi_its_vam_ts_msgs__msg__VamParameters * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // basic_container
  if (!etsi_its_vam_ts_msgs__msg__BasicContainer__are_equal(
      &(lhs->basic_container), &(rhs->basic_container)))
  {
    return false;
  }
  // vru_high_frequency_container
  if (!etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer__are_equal(
      &(lhs->vru_high_frequency_container), &(rhs->vru_high_frequency_container)))
  {
    return false;
  }
  // vru_low_frequency_container
  if (!etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer__are_equal(
      &(lhs->vru_low_frequency_container), &(rhs->vru_low_frequency_container)))
  {
    return false;
  }
  // vru_low_frequency_container_is_present
  if (lhs->vru_low_frequency_container_is_present != rhs->vru_low_frequency_container_is_present) {
    return false;
  }
  // vru_cluster_information_container
  if (!etsi_its_vam_ts_msgs__msg__VruClusterInformationContainer__are_equal(
      &(lhs->vru_cluster_information_container), &(rhs->vru_cluster_information_container)))
  {
    return false;
  }
  // vru_cluster_information_container_is_present
  if (lhs->vru_cluster_information_container_is_present != rhs->vru_cluster_information_container_is_present) {
    return false;
  }
  // vru_cluster_operation_container
  if (!etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__are_equal(
      &(lhs->vru_cluster_operation_container), &(rhs->vru_cluster_operation_container)))
  {
    return false;
  }
  // vru_cluster_operation_container_is_present
  if (lhs->vru_cluster_operation_container_is_present != rhs->vru_cluster_operation_container_is_present) {
    return false;
  }
  // vru_motion_prediction_container
  if (!etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__are_equal(
      &(lhs->vru_motion_prediction_container), &(rhs->vru_motion_prediction_container)))
  {
    return false;
  }
  // vru_motion_prediction_container_is_present
  if (lhs->vru_motion_prediction_container_is_present != rhs->vru_motion_prediction_container_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__VamParameters__copy(
  const etsi_its_vam_ts_msgs__msg__VamParameters * input,
  etsi_its_vam_ts_msgs__msg__VamParameters * output)
{
  if (!input || !output) {
    return false;
  }
  // basic_container
  if (!etsi_its_vam_ts_msgs__msg__BasicContainer__copy(
      &(input->basic_container), &(output->basic_container)))
  {
    return false;
  }
  // vru_high_frequency_container
  if (!etsi_its_vam_ts_msgs__msg__VruHighFrequencyContainer__copy(
      &(input->vru_high_frequency_container), &(output->vru_high_frequency_container)))
  {
    return false;
  }
  // vru_low_frequency_container
  if (!etsi_its_vam_ts_msgs__msg__VruLowFrequencyContainer__copy(
      &(input->vru_low_frequency_container), &(output->vru_low_frequency_container)))
  {
    return false;
  }
  // vru_low_frequency_container_is_present
  output->vru_low_frequency_container_is_present = input->vru_low_frequency_container_is_present;
  // vru_cluster_information_container
  if (!etsi_its_vam_ts_msgs__msg__VruClusterInformationContainer__copy(
      &(input->vru_cluster_information_container), &(output->vru_cluster_information_container)))
  {
    return false;
  }
  // vru_cluster_information_container_is_present
  output->vru_cluster_information_container_is_present = input->vru_cluster_information_container_is_present;
  // vru_cluster_operation_container
  if (!etsi_its_vam_ts_msgs__msg__VruClusterOperationContainer__copy(
      &(input->vru_cluster_operation_container), &(output->vru_cluster_operation_container)))
  {
    return false;
  }
  // vru_cluster_operation_container_is_present
  output->vru_cluster_operation_container_is_present = input->vru_cluster_operation_container_is_present;
  // vru_motion_prediction_container
  if (!etsi_its_vam_ts_msgs__msg__VruMotionPredictionContainer__copy(
      &(input->vru_motion_prediction_container), &(output->vru_motion_prediction_container)))
  {
    return false;
  }
  // vru_motion_prediction_container_is_present
  output->vru_motion_prediction_container_is_present = input->vru_motion_prediction_container_is_present;
  return true;
}

etsi_its_vam_ts_msgs__msg__VamParameters *
etsi_its_vam_ts_msgs__msg__VamParameters__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__VamParameters * msg = (etsi_its_vam_ts_msgs__msg__VamParameters *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__VamParameters), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_vam_ts_msgs__msg__VamParameters));
  bool success = etsi_its_vam_ts_msgs__msg__VamParameters__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_vam_ts_msgs__msg__VamParameters__destroy(etsi_its_vam_ts_msgs__msg__VamParameters * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_vam_ts_msgs__msg__VamParameters__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_vam_ts_msgs__msg__VamParameters__Sequence__init(etsi_its_vam_ts_msgs__msg__VamParameters__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__VamParameters * data = NULL;

  if (size) {
    data = (etsi_its_vam_ts_msgs__msg__VamParameters *)allocator.zero_allocate(size, sizeof(etsi_its_vam_ts_msgs__msg__VamParameters), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_vam_ts_msgs__msg__VamParameters__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_vam_ts_msgs__msg__VamParameters__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_vam_ts_msgs__msg__VamParameters__Sequence__fini(etsi_its_vam_ts_msgs__msg__VamParameters__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_vam_ts_msgs__msg__VamParameters__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_vam_ts_msgs__msg__VamParameters__Sequence *
etsi_its_vam_ts_msgs__msg__VamParameters__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_vam_ts_msgs__msg__VamParameters__Sequence * array = (etsi_its_vam_ts_msgs__msg__VamParameters__Sequence *)allocator.allocate(sizeof(etsi_its_vam_ts_msgs__msg__VamParameters__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_vam_ts_msgs__msg__VamParameters__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_vam_ts_msgs__msg__VamParameters__Sequence__destroy(etsi_its_vam_ts_msgs__msg__VamParameters__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_vam_ts_msgs__msg__VamParameters__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_vam_ts_msgs__msg__VamParameters__Sequence__are_equal(const etsi_its_vam_ts_msgs__msg__VamParameters__Sequence * lhs, const etsi_its_vam_ts_msgs__msg__VamParameters__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__VamParameters__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_vam_ts_msgs__msg__VamParameters__Sequence__copy(
  const etsi_its_vam_ts_msgs__msg__VamParameters__Sequence * input,
  etsi_its_vam_ts_msgs__msg__VamParameters__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_vam_ts_msgs__msg__VamParameters);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_vam_ts_msgs__msg__VamParameters * data =
      (etsi_its_vam_ts_msgs__msg__VamParameters *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_vam_ts_msgs__msg__VamParameters__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_vam_ts_msgs__msg__VamParameters__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_vam_ts_msgs__msg__VamParameters__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
